package kr.co.vividnext.sodalive.admin.content.series

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/audio-content/series")
class AdminContentSeriesController(private val service: AdminContentSeriesService) {
    @GetMapping
    fun getSeriesList(pageable: Pageable) = ApiResponse.ok(service.getSeriesList(pageable))
}
