package kr.co.vividnext.sodalive.admin.content.series.genre

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.PutMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/audio-content/series/genre")
class AdminContentSeriesGenreController(private val service: AdminContentSeriesGenreService) {
    @PostMapping
    fun createSeriesGenre(@RequestBody request: CreateSeriesGenreRequest) =
        ApiResponse.ok(service.createSeriesGenre(genre = request.genre, isAdult = request.isAdult), "생성되었습니다.")

    @PutMapping
    fun modifySeriesGenre(@RequestBody request: ModifySeriesGenreRequest) = ApiResponse.ok(
        service.modifySeriesGenre(request = request),
        "수정되었습니다."
    )

    @PutMapping("/orders")
    fun modifySeriesGenreOrders(@RequestBody request: ModifySeriesGenreOrderRequest) = ApiResponse.ok(
        service.modifySeriesGenreOrders(ids = request.ids),
        "수정되었습니다."
    )

    @GetMapping
    fun getSeriesGenreList() = ApiResponse.ok(service.getSeriesGenreList())
}
