package kr.co.vividnext.sodalive.admin.content.series.genre

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.admin.content.series.genre.QSeriesGenre.seriesGenre
import org.springframework.data.jpa.repository.JpaRepository

interface AdminContentSeriesGenreRepository : JpaRepository<SeriesGenre, Long>, AdminContentSeriesGenreQueryRepository

interface AdminContentSeriesGenreQueryRepository {
    fun getSeriesGenreList(): List<GetSeriesGenreListResponse>
}

class AdminContentSeriesGenreQueryRepositoryImpl(
    private val queryFactory: JPAQueryFactory
) : AdminContentSeriesGenreQueryRepository {
    override fun getSeriesGenreList(): List<GetSeriesGenreListResponse> {
        return queryFactory
            .select(QGetSeriesGenreListResponse(seriesGenre.id, seriesGenre.genre, seriesGenre.isAdult))
            .from(seriesGenre)
            .where(seriesGenre.isActive.isTrue)
            .orderBy(seriesGenre.orders.asc())
            .fetch()
    }
}
