package kr.co.vividnext.sodalive.agora

import kr.co.vividnext.sodalive.agora.AccessToken.Privileges
import org.springframework.stereotype.Component

@Component
class RtmTokenBuilder {

    lateinit var mTokenCreator: AccessToken

    @Throws(Exception::class)
    fun buildToken(
        appId: String,
        appCertificate: String,
        uid: String,
        privilegeTs: Int
    ): String {
        mTokenCreator = AccessToken(appId, appCertificate, uid, "")
        mTokenCreator.addPrivilege(Privileges.RtmLogin, privilegeTs)
        return mTokenCreator.build()
    }

    fun setPrivilege(privilege: Privileges?, expireTs: Int) {
        mTokenCreator.addPrivilege(privilege!!, expireTs)
    }

    fun initTokenBuilder(originToken: String?): Boolean {
        mTokenCreator.fromString(originToken!!)
        return true
    }
}
