package kr.co.vividnext.sodalive.can.use

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.content.AudioContent
import kr.co.vividnext.sodalive.content.order.Order
import kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.CreatorCommunity
import kr.co.vividnext.sodalive.live.room.LiveRoom
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.CascadeType
import javax.persistence.Entity
import javax.persistence.EnumType
import javax.persistence.Enumerated
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToMany
import javax.persistence.OneToOne

@Entity
data class UseCan(
    @Enumerated(value = EnumType.STRING)
    val canUsage: CanUsage,

    val can: Int,

    val rewardCan: Int,

    var isRefund: Boolean = false,

    val isSecret: Boolean = false
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "room_id", nullable = true)
    var room: LiveRoom? = null
        set(value) {
            value?.useCan?.add(this)
            field = value
        }

    @OneToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "order_id", nullable = true)
    var order: Order? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "content_id", nullable = true)
    var audioContent: AudioContent? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "creator_community_id", nullable = true)
    var communityPost: CreatorCommunity? = null

    @OneToMany(mappedBy = "useCan", cascade = [CascadeType.ALL])
    val useCanCalculates: MutableList<UseCanCalculate> = mutableListOf()
}
