package kr.co.vividnext.sodalive.can.use

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.can.use.QUseCan.useCan
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface UseCanRepository : JpaRepository<UseCan, Long>, UseCanQueryRepository

interface UseCanQueryRepository {
    fun isExistOrdered(postId: Long, memberId: Long): Boolean
}

class UseCanQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : UseCanQueryRepository {
    override fun isExistOrdered(postId: Long, memberId: Long): Boolean {
        val useCanId = queryFactory.select(useCan.id)
            .from(useCan)
            .where(
                useCan.member.id.eq(memberId)
                    .and(useCan.isRefund.isFalse)
                    .and(useCan.communityPost.id.eq(postId))
            )
            .fetchFirst()

        return useCanId != null && useCanId > 0
    }
}
